﻿//------------------------------------------------------------------------------
// 2016.12.07 by Aone QQ 1467948783                                            -
// http://www.cnblogs.com/onechen/                                             -
//------------------------------------------------------------------------------

unit Main;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.Objects,
  FMX.Controls.Presentation, FMX.ScrollBox, FMX.Memo, FMX.Layouts;

type
  TForm1 = class(TForm)
    Rectangle1: TRectangle;
    Rectangle2: TRectangle;
    Memo1: TMemo;
    Layout1: TLayout;
    procedure FormTouch(Sender: TObject; const Touches: TTouches;
      const Action: TTouchAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

procedure TForm1.FormTouch(Sender: TObject; const Touches: TTouches;
  const Action: TTouchAction);
var i, j: Integer;
    RectangleAry: TArray<TRectangle>;
begin
     // 展示 OnTouch 事件应用，可同时多指移动多个不同控件 (by Anone)
     // OnTouch 事件只支持含触控功能的设备，如：Android, iOS, Win平板，不支持一般 Windows 系统

     SetLength(RectangleAry, Length(Touches));

     Memo1.Lines.BeginUpdate;
     Memo1.Lines.Clear;

     // 记录按到的控件
     for i:=0 to Length(Touches) - 1 do
     begin
          RectangleAry[i] := nil;

          for j:=0 to Layout1.ChildrenCount - 1 do
          begin
               if (Layout1.Children[j] is TRectangle) and
                  PtInRect(TRectangle(Layout1.Children[j]).BoundsRect, Touches[i].Location) then
               begin
                    RectangleAry[i] := TRectangle(Layout1.Children[j]);
                    Memo1.Lines.Add(Format('%d: %s', [i, RectangleAry[i].Name]));
                    Break;
               end;
          end;
     end;

     Memo1.Lines.EndUpdate;

     // 移动控件
     for i:=0 to Length(Touches) - 1 do
     begin
          if RectangleAry[i] <> nil then
          begin
               RectangleAry[i].Position.X := Trunc(Touches[i].Location.X) - RectangleAry[i].LocalRect.Width / 2;
               RectangleAry[i].Position.Y := Trunc(Touches[i].Location.Y) - RectangleAry[i].LocalRect.Height / 2;
          end;
     end;
end;

end.
